diff --git a/gcc/calls.c b/gcc/calls.c
index f0c92dd..4e0a838 100644
--- a/gcc/calls.c
+++ b/gcc/calls.c
@@ -187,7 +187,7 @@ prepare_call_address (tree fndecl, rtx funexp, rtx static_chain_value,
   else if (! sibcallp)
     {
 #ifndef NO_FUNCTION_CSE
-      if (optimize && ! flag_no_function_cse)
+      if (GCC_OPTION (optimize) && ! GCC_OPTION (flag_no_function_cse))
 	funexp = force_reg (Pmode, funexp);
 #endif
     }
@@ -466,7 +466,7 @@ emit_call_1 (rtx funexp, tree fntree ATTRIBUTE_UNUSED, tree fndecl ATTRIBUTE_UNU
 	  if (ecf_flags & ECF_NORETURN)
 	    /* Just pretend we did the pop.  */
 	    stack_pointer_delta -= rounded_stack_size;
-	  else if (flag_defer_pop && inhibit_defer_pop == 0
+	  else if (GCC_OPTION (flag_defer_pop) && inhibit_defer_pop == 0
 	      && ! (ecf_flags & (ECF_CONST | ECF_PURE)))
 	    pending_stack_adjust += rounded_stack_size;
 	  else
@@ -747,7 +747,7 @@ flags_from_decl_or_type (const_tree exp)
       if (TREE_NOTHROW (exp))
 	flags |= ECF_NOTHROW;
 
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	{
 	  if (is_tm_builtin (exp))
 	    flags |= ECF_TM_BUILTIN;
@@ -764,7 +764,7 @@ flags_from_decl_or_type (const_tree exp)
       if (TYPE_READONLY (exp))
 	flags |= ECF_CONST;
 
-      if (flag_tm
+      if (GCC_OPTION (flag_tm)
 	  && ((flags & ECF_CONST) != 0
 	      || lookup_attribute ("transaction_pure", TYPE_ATTRIBUTES (exp))))
 	flags |= ECF_TM_PURE;
@@ -874,7 +874,7 @@ precompute_register_parameters (int num_actuals, struct arg_data *args,
 		    > COSTS_N_INSNS (1)
 		 && ((*reg_parm_seen
 		      && targetm.small_register_classes_for_mode_p (args[i].mode))
-		     || optimize))
+		     || GCC_OPTION (optimize)))
 	  args[i].value = copy_to_mode_reg (args[i].mode, args[i].value);
       }
 }
@@ -1235,7 +1235,7 @@ initialize_argument_information (int num_actuals ATTRIBUTE_UNUSED,
 
 	      if (!COMPLETE_TYPE_P (type)
 		  || TREE_CODE (TYPE_SIZE_UNIT (type)) != INTEGER_CST
-		  || (flag_stack_check == GENERIC_STACK_CHECK
+		  || (GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK
 		      && compare_tree_int (TYPE_SIZE_UNIT (type),
 					   STACK_CHECK_MAX_VAR_SIZE) > 0))
 		{
@@ -2573,7 +2573,7 @@ expand_call (tree exp, rtx target, int ignore)
      there's cleanups, as we know there's code to follow the call.  */
 
   if (currently_expanding_call++ != 0
-      || !flag_optimize_sibling_calls
+      || !GCC_OPTION (flag_optimize_sibling_calls)
       || args_size.var
       || dbg_cnt (tail_call) == false)
     try_tail_call = 0;
@@ -2710,7 +2710,7 @@ expand_call (tree exp, rtx target, int ignore)
 	  || (pending_stack_adjust > 0
 	      && (flags & ECF_MAY_BE_ALLOCA))
 	  || (pending_stack_adjust > 0
-	      && flag_exceptions && !(flags & ECF_NOTHROW))
+	      && GCC_OPTION (flag_exceptions) && !(flags & ECF_NOTHROW))
 	  || pass == 0)
 	do_pending_stack_adjust ();
 
@@ -2773,7 +2773,7 @@ expand_call (tree exp, rtx target, int ignore)
 	      stack_arg_under_construction = 0;
 	    }
 	  argblock = push_block (ARGS_SIZE_RTX (adjusted_args_size), 0, 0);
-	  if (flag_stack_usage_info)
+	  if (GCC_OPTION (flag_stack_usage_info))
 	    current_function_has_unbounded_dynamic_stack_size = 1;
 	}
       else
@@ -2981,7 +2981,7 @@ expand_call (tree exp, rtx target, int ignore)
       /* Record the maximum pushed stack space size.  We need to delay
 	 doing it this far to take into account the optimization done
 	 by combine_pending_stack_adjustment_and_call.  */
-      if (flag_stack_usage_info
+      if (GCC_OPTION (flag_stack_usage_info)
 	  && !ACCUMULATE_OUTGOING_ARGS
 	  && pass
 	  && adjusted_args_size.var == 0)
@@ -3881,7 +3881,7 @@ emit_library_call_value_1 (int retval, rtx orgfun, rtx value,
   if (args_size.constant > crtl->outgoing_args_size)
     crtl->outgoing_args_size = args_size.constant;
 
-  if (flag_stack_usage_info && !ACCUMULATE_OUTGOING_ARGS)
+  if (GCC_OPTION (flag_stack_usage_info) && !ACCUMULATE_OUTGOING_ARGS)
     {
       int pushed = args_size.constant + pending_stack_adjust;
       if (pushed > current_function_pushed_stack_size)
diff --git a/gcc/cfgbuild.c b/gcc/cfgbuild.c
index ae1f114..49fe2b1 100644
--- a/gcc/cfgbuild.c
+++ b/gcc/cfgbuild.c
@@ -346,7 +346,7 @@ make_edges (basic_block min, basic_block max, int update_p)
 				     EDGE_ABNORMAL | EDGE_ABNORMAL_CALL);
 		}
 
-	      if (flag_tm)
+	      if (GCC_OPTION (flag_tm))
 		{
 		  rtx note;
 		  for (note = REG_NOTES (insn); note; note = XEXP (note, 1))
diff --git a/gcc/cfgcleanup.c b/gcc/cfgcleanup.c
index 77196ee..f2556c1 100644
--- a/gcc/cfgcleanup.c
+++ b/gcc/cfgcleanup.c
@@ -473,7 +473,7 @@ try_forward_edges (int mode, basic_block b)
 	      new_target = single_succ (target);
 	      if (target == new_target)
 		counter = n_basic_blocks_for_fn (cfun);
-	      else if (!optimize)
+	      else if (!GCC_OPTION (optimize))
 		{
 		  /* When not optimizing, ensure that edges or forwarder
 		     blocks with different locus are not optimized out.  */
@@ -1159,7 +1159,7 @@ old_insns_match_p (int mode ATTRIBUTE_UNUSED, rtx i1, rtx i2)
 
       /* For address sanitizer, never crossjump __asan_report_* builtins,
 	 otherwise errors might be reported on incorrect lines.  */
-      if (flag_sanitize & SANITIZE_ADDRESS)
+      if (GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS)
 	{
 	  rtx call = get_call_rtx_from (i1);
 	  if (call && GET_CODE (XEXP (XEXP (call, 0), 0)) == SYMBOL_REF)
@@ -3084,8 +3084,8 @@ execute_jump (void)
   delete_trivially_dead_insns (get_insns (), max_reg_num ());
   if (dump_file)
     dump_flow_info (dump_file, dump_flags);
-  cleanup_cfg ((optimize ? CLEANUP_EXPENSIVE : 0)
-	       | (flag_thread_jumps ? CLEANUP_THREADING : 0));
+  cleanup_cfg ((GCC_OPTION (optimize) ? CLEANUP_EXPENSIVE : 0)
+	       | (GCC_OPTION (flag_thread_jumps) ? CLEANUP_THREADING : 0));
   return 0;
 }
 
@@ -3129,7 +3129,7 @@ make_pass_jump (gcc::context *ctxt)
 static unsigned int
 execute_jump2 (void)
 {
-  cleanup_cfg (flag_crossjumping ? CLEANUP_CROSSJUMP : 0);
+  cleanup_cfg (GCC_OPTION (flag_crossjumping) ? CLEANUP_CROSSJUMP : 0);
   return 0;
 }
 
diff --git a/gcc/cfgexpand.c b/gcc/cfgexpand.c
index b7f6360..32de2ea 100644
--- a/gcc/cfgexpand.c
+++ b/gcc/cfgexpand.c
@@ -798,7 +798,7 @@ partition_stack_vars (void)
 	     sizes, as the shorter vars wouldn't be adequately protected.
 	     Don't do that for "large" (unsupported) alignment objects,
 	     those aren't protected anyway.  */
-	  if ((flag_sanitize & SANITIZE_ADDRESS) && ASAN_STACK && isize != jsize
+	  if ((GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS) && ASAN_STACK && isize != jsize
 	      && ialign * BITS_PER_UNIT <= MAX_SUPPORTED_STACK_ALIGNMENT)
 	    break;
 
@@ -981,7 +981,7 @@ expand_stack_vars (bool (*pred) (size_t), struct stack_vars_data *data)
       if (alignb * BITS_PER_UNIT <= MAX_SUPPORTED_STACK_ALIGNMENT)
 	{
 	  base = virtual_stack_vars_rtx;
-	  if ((flag_sanitize & SANITIZE_ADDRESS) && ASAN_STACK && pred)
+	  if ((GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS) && ASAN_STACK && pred)
 	    {
 	      HOST_WIDE_INT prev_offset = frame_offset;
 	      tree repr_decl = NULL_TREE;
@@ -1160,7 +1160,7 @@ defer_stack_allocation (tree var, bool toplevel)
   /* If stack protection is enabled, *all* stack variables must be deferred,
      so that we can re-order the strings to the top of the frame.
      Similarly for Address Sanitizer.  */
-  if (flag_stack_protect || ((flag_sanitize & SANITIZE_ADDRESS) && ASAN_STACK))
+  if (GCC_OPTION (flag_stack_protect) || ((GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS) && ASAN_STACK))
     return true;
 
   /* We handle "large" alignment via dynamic allocation.  We want to handle
@@ -1172,14 +1172,14 @@ defer_stack_allocation (tree var, bool toplevel)
      might be detached from their block and appear at toplevel when we reach
      here.  We want to coalesce them with variables from other blocks when
      the immediate contribution to the frame size would be noticeable.  */
-  if (toplevel && optimize > 0 && DECL_IGNORED_P (var) && !smallish)
+  if (toplevel && GCC_OPTION (optimize) > 0 && DECL_IGNORED_P (var) && !smallish)
     return true;
 
   /* Variables declared in the outermost scope automatically conflict
      with every other variable.  The only reason to want to defer them
      at all is that, after sorting, we can more efficiently pack
      small variables in the stack frame.  Continue to defer at -O2.  */
-  if (toplevel && optimize < 2)
+  if (toplevel && GCC_OPTION (optimize) < 2)
     return false;
 
   /* Without optimization, *most* variables are allocated from the
@@ -1188,7 +1188,7 @@ defer_stack_allocation (tree var, bool toplevel)
      other hand, we don't want the function's stack frame size to
      get completely out of hand.  So we avoid adding scalars and
      "small" aggregates to the list at all.  */
-  if (optimize == 0 && smallish)
+  if (GCC_OPTION (optimize) == 0 && smallish)
     return false;
 
   return true;
@@ -1426,8 +1426,8 @@ stack_protect_decl_phase (tree decl)
   if (bits & SPCT_HAS_SMALL_CHAR_ARRAY)
     has_short_buffer = true;
 
-  if (flag_stack_protect == SPCT_FLAG_ALL
-      || flag_stack_protect == SPCT_FLAG_STRONG)
+  if (GCC_OPTION (flag_stack_protect) == SPCT_FLAG_ALL
+      || GCC_OPTION (flag_stack_protect) == SPCT_FLAG_STRONG)
     {
       if ((bits & (SPCT_HAS_SMALL_CHAR_ARRAY | SPCT_HAS_LARGE_CHAR_ARRAY))
 	  && !(bits & SPCT_HAS_AGGREGATE))
@@ -1657,7 +1657,7 @@ expand_used_vars (void)
 	 link performed at -O0.  */
       if (TREE_CODE (SSA_NAME_VAR (var)) == VAR_DECL)
 	expand_one_var (var, true, true);
-      else if (DECL_IGNORED_P (SSA_NAME_VAR (var)) || optimize || in_lto_p)
+      else if (DECL_IGNORED_P (SSA_NAME_VAR (var)) || GCC_OPTION (optimize) || GCC_OPTION (in_lto_p))
 	{
 	  /* This is a PARM_DECL or RESULT_DECL.  For those partitions that
 	     contain the default def (representing the parm or result itself)
@@ -1673,7 +1673,7 @@ expand_used_vars (void)
     }
   pointer_map_destroy (ssa_name_decls);
 
-  if (flag_stack_protect == SPCT_FLAG_STRONG)
+  if (GCC_OPTION (flag_stack_protect) == SPCT_FLAG_STRONG)
     FOR_EACH_LOCAL_DECL (cfun, i, var)
       if (!is_global_var (var))
 	{
@@ -1769,7 +1769,7 @@ expand_used_vars (void)
 
       /* If stack protection is enabled, we don't share space between
 	 vulnerable data and non-vulnerable data.  */
-      if (flag_stack_protect)
+      if (GCC_OPTION (flag_stack_protect))
 	add_stack_protection_conflicts ();
 
       /* Now that we have collected all stack variables, and have computed a
@@ -1779,7 +1779,7 @@ expand_used_vars (void)
 	dump_stack_var_partition ();
     }
 
-  switch (flag_stack_protect)
+  switch (GCC_OPTION (flag_stack_protect))
     {
     case SPCT_FLAG_ALL:
       create_stack_guard ();
@@ -1821,11 +1821,11 @@ expand_used_vars (void)
 	  expand_stack_vars (stack_protect_decl_phase_1, &data);
 
 	  /* Phase 2 contains other kinds of arrays.  */
-	  if (flag_stack_protect == 2)
+	  if (GCC_OPTION (flag_stack_protect) == 2)
 	    expand_stack_vars (stack_protect_decl_phase_2, &data);
 	}
 
-      if ((flag_sanitize & SANITIZE_ADDRESS) && ASAN_STACK)
+      if ((GCC_OPTION (flag_sanitize) & SANITIZE_ADDRESS) && ASAN_STACK)
 	/* Phase 3, any partitions that need asan protection
 	   in addition to phase 1 and 2.  */
 	expand_stack_vars (asan_decl_phase_3, &data);
@@ -4775,12 +4775,12 @@ expand_debug_locations (void)
 {
   rtx insn;
   rtx last = get_last_insn ();
-  int save_strict_alias = flag_strict_aliasing;
+  int save_strict_alias = GCC_OPTION (flag_strict_aliasing);
 
   /* New alias sets while setting up memory attributes cause
      -fcompare-debug failures, even though it doesn't bring about any
      codegen changes.  */
-  flag_strict_aliasing = 0;
+  GCC_OPTION (flag_strict_aliasing) = 0;
 
   for (insn = get_insns (); insn; insn = NEXT_INSN (insn))
     if (DEBUG_INSN_P (insn))
@@ -4820,7 +4820,7 @@ expand_debug_locations (void)
 	  avoid_complex_debug_insns (insn2, &INSN_VAR_LOCATION_LOC (insn2), 0);
       }
 
-  flag_strict_aliasing = save_strict_alias;
+  GCC_OPTION (flag_strict_aliasing) = save_strict_alias;
 }
 
 /* Expand basic block BB from GIMPLE trees to RTL.  */
@@ -5591,7 +5591,7 @@ gimple_expand_cfg (void)
 
   /* Resovle the function section.  Some targets, like ARM EABI rely on knowledge
      of the function section at exapnsion time to predict distance of calls.  */
-  resolve_unique_section (current_function_decl, 0, flag_function_sections);
+  resolve_unique_section (current_function_decl, 0, GCC_OPTION (flag_function_sections));
 
   /* Expand the variables recorded during gimple lowering.  */
   timevar_push (TV_VAR_EXPAND);
@@ -5604,7 +5604,7 @@ gimple_expand_cfg (void)
   timevar_pop (TV_VAR_EXPAND);
 
   /* Honor stack protection warnings.  */
-  if (warn_stack_protect)
+  if (GCC_OPTION (warn_stack_protect))
     {
       if (cfun->calls_alloca)
 	warning (OPT_Wstack_protector,
diff --git a/gcc/cfgloopanal.c b/gcc/cfgloopanal.c
index e01b9cc..7a90da9 100644
--- a/gcc/cfgloopanal.c
+++ b/gcc/cfgloopanal.c
@@ -409,8 +409,8 @@ estimate_reg_pressure_cost (unsigned n_new, unsigned n_old, bool speed,
        one.  */
     cost = target_spill_cost [speed] * n_new;
 
-  if (optimize && (flag_ira_region == IRA_REGION_ALL
-		   || flag_ira_region == IRA_REGION_MIXED)
+  if (GCC_OPTION (optimize) && (GCC_OPTION (flag_ira_region) == IRA_REGION_ALL
+		   || GCC_OPTION (flag_ira_region) == IRA_REGION_MIXED)
       && number_of_loops (cfun) <= (unsigned) IRA_MAX_LOOPS_NUM)
     /* IRA regional allocation deals with high register pressure
        better.  So decrease the cost (to do more accurate the cost
diff --git a/gcc/cfgrtl.c b/gcc/cfgrtl.c
index 60b0c06..47c1c7c 100644
--- a/gcc/cfgrtl.c
+++ b/gcc/cfgrtl.c
@@ -448,7 +448,7 @@ rest_of_pass_free_cfg (void)
 #ifdef DELAY_SLOTS
   /* The resource.c machinery uses DF but the CFG isn't guaranteed to be
      valid at that point so it would be too late to call df_analyze.  */
-  if (optimize > 0 && flag_delayed_branch)
+  if (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_delayed_branch))
     {
       df_note_add_problem ();
       df_analyze ();
@@ -892,7 +892,7 @@ rtl_merge_blocks (basic_block a, basic_block b)
 
   /* When not optimizing CFG and the edge is the only place in RTL which holds
      some unique locus, emit a nop with that locus in between.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     {
       emit_nop_for_unique_locus_between (a, b);
       a_end = BB_END (a);
@@ -1025,7 +1025,7 @@ try_redirect_by_replacing_jump (edge e, basic_block target, bool in_cfglayout)
 
   if (!onlyjump_p (insn))
     return NULL;
-  if ((!optimize || reload_completed) && tablejump_p (insn, NULL, NULL))
+  if ((!GCC_OPTION (optimize) || reload_completed) && tablejump_p (insn, NULL, NULL))
     return NULL;
 
   /* Avoid removing branch with side effects.  */
@@ -3017,7 +3017,7 @@ purge_dead_edges (basic_block bb)
 	    ;
 	  else if ((e->flags & EDGE_EH) && can_throw_internal (insn))
 	    ;
-	  else if (flag_tm && find_reg_note (insn, REG_TM, NULL))
+	  else if (GCC_OPTION (flag_tm) && find_reg_note (insn, REG_TM, NULL))
 	    ;
 	  else
 	    remove = true;
@@ -3111,7 +3111,7 @@ purge_dead_edges (basic_block bb)
       if (dump_file)
 	fprintf (dump_file, "Purged edges from bb %i\n", bb->index);
 
-      if (!optimize)
+      if (!GCC_OPTION (optimize))
 	return purged;
 
       /* Redistribute probabilities.  */
@@ -3868,7 +3868,7 @@ fixup_reorder_chain (void)
 
   /* Ensure goto_locus from edges has some instructions with that locus
      in RTL.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     FOR_EACH_BB_FN (bb, cfun)
       {
         edge e;
@@ -4540,7 +4540,7 @@ cfg_layout_can_merge_blocks_p (basic_block a, basic_block b)
 	     When not optimizing, try_redirect_by_replacing_jump will
 	     not allow us to redirect an edge by replacing a table jump.  */
 	  && (!JUMP_P (BB_END (a))
-	      || ((!optimize || reload_completed)
+	      || ((!GCC_OPTION (optimize) || reload_completed)
 		  ? simplejump_p (BB_END (a)) : onlyjump_p (BB_END (a)))));
 }
 
@@ -4572,7 +4572,7 @@ cfg_layout_merge_blocks (basic_block a, basic_block b)
 
   /* When not optimizing CFG and the edge is the only place in RTL which holds
      some unique locus, emit a nop with that locus in between.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     emit_nop_for_unique_locus_between (a, b);
 
   /* Move things from b->footer after a->footer.  */
diff --git a/gcc/cgraph.c b/gcc/cgraph.c
index 577352f..390b5bb 100644
--- a/gcc/cgraph.c
+++ b/gcc/cgraph.c
@@ -1788,7 +1788,7 @@ cgraph_remove_node (struct cgraph_node *node)
 		  && (TREE_ASM_WRITTEN (n->decl)
 		      || DECL_EXTERNAL (n->decl)
 		      || !n->analyzed
-		      || (!flag_wpa && n->in_other_partition)))))
+		      || (!GCC_OPTION (flag_wpa) && n->in_other_partition)))))
 	cgraph_release_function_body (node);
     }
 
@@ -2349,7 +2349,7 @@ bool
 cgraph_node_cannot_return (struct cgraph_node *node)
 {
   int flags = flags_from_decl_or_type (node->decl);
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return (flags & ECF_NORETURN) != 0;
   else
     return ((flags & (ECF_NORETURN | ECF_NOTHROW))
@@ -2369,7 +2369,7 @@ cgraph_edge_cannot_lead_to_return (struct cgraph_edge *e)
   if (e->indirect_unknown_callee)
     {
       int flags = e->indirect_info->ecf_flags;
-      if (!flag_exceptions)
+      if (!GCC_OPTION (flag_exceptions))
 	return (flags & ECF_NORETURN) != 0;
       else
 	return ((flags & (ECF_NORETURN | ECF_NOTHROW))
@@ -2454,7 +2454,7 @@ cgraph_will_be_removed_from_program_if_no_direct_calls (struct cgraph_node *node
   gcc_assert (!node->global.inlined_to);
   if (cgraph_for_node_and_aliases (node, used_from_object_file_p, NULL, true))
     return false;
-  if (!in_lto_p && !flag_whole_program)
+  if (!GCC_OPTION (in_lto_p) && !GCC_OPTION (flag_whole_program))
     return cgraph_only_called_directly_p (node);
   else
     {
@@ -2830,7 +2830,7 @@ verify_cgraph_node (struct cgraph_node *node)
   else if (node->analyzed && gimple_has_body_p (node->decl)
            && !TREE_ASM_WRITTEN (node->decl)
            && (!DECL_EXTERNAL (node->decl) || node->global.inlined_to)
-           && !flag_wpa)
+           && !GCC_OPTION (flag_wpa))
     {
       if (this_cfun->cfg)
 	{
@@ -2992,7 +2992,7 @@ cgraph_get_body (struct cgraph_node *node)
   if (DECL_RESULT (decl))
     return false;
 
-  gcc_assert (in_lto_p);
+  gcc_assert (GCC_OPTION (in_lto_p));
 
   file_data = node->lto_file_data;
   name = IDENTIFIER_POINTER (DECL_ASSEMBLER_NAME (decl));
diff --git a/gcc/cgraphclones.c b/gcc/cgraphclones.c
index ca69033..bca5a03 100644
--- a/gcc/cgraphclones.c
+++ b/gcc/cgraphclones.c
@@ -416,7 +416,7 @@ cgraph_create_virtual_clone (struct cgraph_node *old_node,
   struct ipa_replace_map *map;
   char *name;
 
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     gcc_checking_assert  (tree_versionable_function_p (old_decl));
 
   gcc_assert (old_node->local.can_change_signature || !args_to_skip);
@@ -473,7 +473,7 @@ cgraph_create_virtual_clone (struct cgraph_node *old_node,
        && !DECL_EXTERNAL (old_decl)
        && !DECL_WEAK (old_decl)
        && !DECL_COMDAT (old_decl))
-      || in_lto_p)
+      || GCC_OPTION (in_lto_p))
     new_node->unique_name = true;
   FOR_EACH_VEC_SAFE_ELT (tree_map, i, map)
     ipa_maybe_record_reference (new_node, map->new_tree,
@@ -897,7 +897,7 @@ cgraph_function_versioning (struct cgraph_node *old_version_node,
        && !DECL_EXTERNAL (old_decl)
        && !DECL_WEAK (old_decl)
        && !DECL_COMDAT (old_decl))
-      || in_lto_p)
+      || GCC_OPTION (in_lto_p))
     new_version_node->unique_name = true;
 
   /* Update the call_expr on the edges to call the new version node. */
diff --git a/gcc/cgraphunit.c b/gcc/cgraphunit.c
index 06283fc..85572f9 100644
--- a/gcc/cgraphunit.c
+++ b/gcc/cgraphunit.c
@@ -437,7 +437,7 @@ cgraph_finalize_function (tree decl, bool no_collect)
 
   /* With -fkeep-inline-functions we are keeping all inline functions except
      for extern inline ones.  */
-  if (flag_keep_inline_functions
+  if (GCC_OPTION (flag_keep_inline_functions)
       && DECL_DECLARED_INLINE_P (decl)
       && !DECL_EXTERNAL (decl)
       && !DECL_DISREGARD_INLINE_LIMITS (decl))
@@ -448,7 +448,7 @@ cgraph_finalize_function (tree decl, bool no_collect)
      declared inline and nested functions.  These were optimized out
      in the original implementation and it is unclear whether we want
      to change the behavior here.  */
-  if ((!optimize
+  if ((!GCC_OPTION (optimize)
        && !node->cpp_implicit_alias
        && !DECL_DISREGARD_INLINE_LIMITS (decl)
        && !DECL_DECLARED_INLINE_P (decl)
@@ -462,7 +462,7 @@ cgraph_finalize_function (tree decl, bool no_collect)
     (*debug_hooks->deferred_inline_function) (decl);
 
   /* Possibly warn about unused parameters.  */
-  if (warn_unused_parameter)
+  if (GCC_OPTION (warn_unused_parameter))
     do_warn_unused_parameter (decl);
 
   if (!no_collect)
@@ -824,7 +824,7 @@ varpool_finalize_decl (tree decl)
   if (TREE_THIS_VOLATILE (decl) || DECL_PRESERVE_P (decl)
       /* Traditionally we do not eliminate static variables when not
 	 optimizing and when not doing toplevel reoder.  */
-      || (!flag_toplevel_reorder && !DECL_COMDAT (node->decl)
+      || (!GCC_OPTION (flag_toplevel_reorder) && !DECL_COMDAT (node->decl)
 	  && !DECL_ARTIFICIAL (node->decl)))
     node->force_output = true;
 
@@ -837,7 +837,7 @@ varpool_finalize_decl (tree decl)
   /* Some frontends produce various interface variables after compilation
      finished.  */
   if (cgraph_state == CGRAPH_STATE_FINISHED
-      || (!flag_toplevel_reorder && cgraph_state == CGRAPH_STATE_EXPANSION))
+      || (!GCC_OPTION (flag_toplevel_reorder) && cgraph_state == CGRAPH_STATE_EXPANSION))
     varpool_assemble_decl (node);
 }
 
@@ -949,7 +949,7 @@ analyze_functions (void)
     FOR_EACH_SYMBOL (node)
       if (node->cpp_implicit_alias)
 	  fixup_same_cpp_alias_visibility (node, symtab_alias_target (node));
-  if (optimize && flag_devirtualize)
+  if (GCC_OPTION (optimize) && GCC_OPTION (flag_devirtualize))
     build_type_inheritance_graph ();
 
   /* Analysis adds static variables that in turn adds references to new functions.
@@ -1019,7 +1019,7 @@ analyze_functions (void)
 	      for (edge = cnode->callees; edge; edge = edge->next_callee)
 		if (edge->callee->definition)
 		   enqueue_node (edge->callee);
-	      if (optimize && flag_devirtualize)
+	      if (GCC_OPTION (optimize) && GCC_OPTION (flag_devirtualize))
 		{
 		  struct cgraph_edge *next;
 
@@ -1064,7 +1064,7 @@ analyze_functions (void)
           cgraph_process_new_functions ();
 	}
     }
-  if (optimize && flag_devirtualize)
+  if (GCC_OPTION (optimize) && GCC_OPTION (flag_devirtualize))
     update_type_inheritance_graph ();
 
   /* Collect entry points to the unit.  */
@@ -1481,14 +1481,14 @@ expand_thunk (struct cgraph_node *node, bool output_asm_thunks)
       if (!output_asm_thunks)
 	return false;
 
-      if (in_lto_p)
+      if (GCC_OPTION (in_lto_p))
 	cgraph_get_body (node);
       a = DECL_ARGUMENTS (thunk_fndecl);
       
       current_function_decl = thunk_fndecl;
 
       /* Ensure thunks are emitted in their correct sections.  */
-      resolve_unique_section (thunk_fndecl, 0, flag_function_sections);
+      resolve_unique_section (thunk_fndecl, 0, GCC_OPTION (flag_function_sections));
 
       DECL_RESULT (thunk_fndecl)
 	= build_decl (DECL_SOURCE_LOCATION (thunk_fndecl),
@@ -1534,14 +1534,14 @@ expand_thunk (struct cgraph_node *node, bool output_asm_thunks)
       gimple call;
       gimple ret;
 
-      if (in_lto_p)
+      if (GCC_OPTION (in_lto_p))
 	cgraph_get_body (node);
       a = DECL_ARGUMENTS (thunk_fndecl);
       
       current_function_decl = thunk_fndecl;
 
       /* Ensure thunks are emitted in their correct sections.  */
-      resolve_unique_section (thunk_fndecl, 0, flag_function_sections);
+      resolve_unique_section (thunk_fndecl, 0, GCC_OPTION (flag_function_sections));
 
       DECL_IGNORED_P (thunk_fndecl) = 1;
       bitmap_obstack_initialize (NULL);
@@ -1784,14 +1784,14 @@ expand_function (struct cgraph_node *node)
   /* If requested, warn about function definitions where the function will
      return a value (usually of some struct or union type) which itself will
      take up a lot of stack space.  */
-  if (warn_larger_than && !DECL_EXTERNAL (decl) && TREE_TYPE (decl))
+  if (GCC_OPTION (warn_larger_than) && !DECL_EXTERNAL (decl) && TREE_TYPE (decl))
     {
       tree ret_type = TREE_TYPE (TREE_TYPE (decl));
 
       if (ret_type && TYPE_SIZE_UNIT (ret_type)
 	  && TREE_CODE (TYPE_SIZE_UNIT (ret_type)) == INTEGER_CST
 	  && 0 < compare_tree_int (TYPE_SIZE_UNIT (ret_type),
-				   larger_than_size))
+				   GCC_OPTION (larger_than_size)))
 	{
 	  unsigned int size_as_int
 	    = TREE_INT_CST_LOW (TYPE_SIZE_UNIT (ret_type));
@@ -1801,7 +1801,7 @@ expand_function (struct cgraph_node *node)
                      decl, size_as_int);
 	  else
 	    warning (OPT_Wlarger_than_, "size of return value of %q+D is larger than %wd bytes",
-                     decl, larger_than_size);
+                     decl, GCC_OPTION (larger_than_size));
 	}
     }
 
@@ -1888,7 +1888,7 @@ expand_all_functions (void)
     if (order[i]->process)
       order[new_order_pos++] = order[i];
 
-  if (flag_profile_reorder_functions)
+  if (GCC_OPTION (flag_profile_reorder_functions))
     qsort (order, new_order_pos, sizeof (struct cgraph_node *), node_cmp);
 
   for (i = new_order_pos - 1; i >= 0; i--)
@@ -1911,9 +1911,9 @@ expand_all_functions (void)
 
     if (dump_file)
       fprintf (dump_file, "Expanded functions with time profile (%s):%u/%u\n",
-               main_input_filename, profiled_func_count, expanded_func_count);
+               GCC_OPTION (main_input_filename), profiled_func_count, expanded_func_count);
 
-  if (cgraph_dump_file && flag_profile_reorder_functions)
+  if (cgraph_dump_file && GCC_OPTION (flag_profile_reorder_functions))
     fprintf (cgraph_dump_file, "Expanded functions with time profile:%u/%u\n",
              profiled_func_count, expanded_func_count);
 
@@ -2038,7 +2038,7 @@ ipa_passes (void)
 
   invoke_plugin_callbacks (PLUGIN_ALL_IPA_PASSES_START, NULL);
 
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     {
       execute_ipa_pass_list (passes->all_small_ipa_passes);
       if (seen_error ())
@@ -2056,7 +2056,7 @@ ipa_passes (void)
   if (cgraph_state < CGRAPH_STATE_IPA_SSA)
     cgraph_state = CGRAPH_STATE_IPA_SSA;
 
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     {
       /* Generate coverage variables and constructors.  */
       coverage_finish ();
@@ -2071,16 +2071,16 @@ ipa_passes (void)
     }
 
   /* Some targets need to handle LTO assembler output specially.  */
-  if (flag_generate_lto)
+  if (GCC_OPTION (flag_generate_lto))
     targetm.asm_out.lto_start ();
 
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
     ipa_write_summaries ();
 
-  if (flag_generate_lto)
+  if (GCC_OPTION (flag_generate_lto))
     targetm.asm_out.lto_end ();
 
-  if (!flag_ltrans && (in_lto_p || !flag_lto || flag_fat_lto_objects))
+  if (!GCC_OPTION (flag_ltrans) && (GCC_OPTION (in_lto_p) || !GCC_OPTION (flag_lto) || GCC_OPTION (flag_fat_lto_objects)))
     execute_ipa_pass_list (passes->all_regular_ipa_passes);
   invoke_plugin_callbacks (PLUGIN_ALL_IPA_PASSES_END, NULL);
 
@@ -2156,17 +2156,17 @@ compile (void)
 #endif
 
   timevar_push (TV_CGRAPHOPT);
-  if (pre_ipa_mem_report)
+  if (GCC_OPTION (pre_ipa_mem_report))
     {
       fprintf (stderr, "Memory consumption before IPA\n");
       dump_memory_report (false);
     }
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "Performing interprocedural optimizations\n");
   cgraph_state = CGRAPH_STATE_IPA;
 
   /* If LTO is enabled, initialize the streamer hooks needed by GIMPLE.  */
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     lto_streamer_hooks_init ();
 
   /* Don't run the IPA passes if there was any error or sorry messages.  */
@@ -2175,7 +2175,7 @@ compile (void)
 
   /* Do nothing else if any IPA pass found errors or if we are just streaming LTO.  */
   if (seen_error ()
-      || (!in_lto_p && flag_lto && !flag_fat_lto_objects))
+      || (!GCC_OPTION (in_lto_p) && GCC_OPTION (flag_lto) && !GCC_OPTION (flag_fat_lto_objects)))
     {
       timevar_pop (TV_CGRAPHOPT);
       return;
@@ -2190,7 +2190,7 @@ compile (void)
       fprintf (cgraph_dump_file, "Optimized ");
       dump_symtab (cgraph_dump_file);
     }
-  if (post_ipa_mem_report)
+  if (GCC_OPTION (post_ipa_mem_report))
     {
       fprintf (stderr, "Memory consumption after IPA\n");
       dump_memory_report (false);
@@ -2199,7 +2199,7 @@ compile (void)
 
   /* Output everything.  */
   (*debug_hooks->assembly_start) ();
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "Assembling functions:\n");
 #ifdef ENABLE_CHECKING
   verify_symtab ();
@@ -2243,7 +2243,7 @@ compile (void)
 
   cgraph_state = CGRAPH_STATE_EXPANSION;
 
-  if (!flag_toplevel_reorder)
+  if (!GCC_OPTION (flag_toplevel_reorder))
     output_in_order ();
   else
     {
@@ -2306,13 +2306,13 @@ finalize_compilation_unit (void)
   /* Mark alias targets necessary and emit diagnostics.  */
   handle_alias_pairs ();
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     {
       fprintf (stderr, "\nAnalyzing compilation unit\n");
       fflush (stderr);
     }
 
-  if (flag_dump_passes)
+  if (GCC_OPTION (flag_dump_passes))
     dump_passes ();
 
   /* Gimplify and lower all functions, compute reachability and
diff --git a/gcc/cilk.h b/gcc/cilk.h
index ae96f53..f1b8b84 100644
--- a/gcc/cilk.h
+++ b/gcc/cilk.h
@@ -97,7 +97,7 @@ extern tree cilk_call_setjmp (tree);
 inline bool
 fn_contains_cilk_spawn_p (function *f)
 {
-  return (flag_cilkplus 
+  return (GCC_OPTION (flag_cilkplus) 
 	  && (f->calls_cilk_spawn || f->cilk_frame_decl != NULL_TREE));
 }
 
diff --git a/gcc/combine-stack-adj.c b/gcc/combine-stack-adj.c
index 69fd5ea..a660436 100644
--- a/gcc/combine-stack-adj.c
+++ b/gcc/combine-stack-adj.c
@@ -631,7 +631,7 @@ gate_handle_stack_adjustments (void)
   if (ACCUMULATE_OUTGOING_ARGS)
     return false;
 #endif
-  return flag_combine_stack_adjustments;
+  return GCC_OPTION (flag_combine_stack_adjustments);
 }
 
 static unsigned int
